/*                              Aum Sri Sairam                           		 */
/*                                                                       		 */
/*#######################################################################################*/
/*#                                                                     		#*/
/*#                                                                     		#*/
/*#	PROGRAM TO GENERATE  gen_data Program  FOR THE ANN  FROM THE anndata FILE	#*/
/*#		CREATED FROM THE PROGRAM get_data.c					#*/
/*#                                        		       		                #*/
/*#                                          		   	- ANANTH(ARUP 307)      #*/
/*#                                                   			                #*/
/*#######################################################################################*/
/*                                                                            		 */
/* 		                                                                         */
/*                                                                       		 */
/*                                                                       		 */

#include<stdio.h>
#include <unistd.h>

main(argc, argv)

     int argc;
     char* argv[];

{
  int var,i,ord_opt;
  char fname[100],filename[100],model_name[100],test_dat_file[50],iden[50];
  FILE *fp;

  system("clear");
  heading();
  instructions();
  
  strcpy(iden,argv[5]);
  ord_opt=atoi(argv[6]);
  for(i=1;i<=4;i++)
    {
      switch(i)
	{
	case 1:strcpy(model_name,"ys");strcpy(filename,"ys_anndata");strcpy(test_dat_file,"ys_test.dat");var=atoi(argv[1]);break;
	case 2:strcpy(model_name,"chp");strcpy(filename,"chp_anndata");strcpy(test_dat_file,"chp_test.dat");var=atoi(argv[2]);break;
	case 3:strcpy(model_name,"uts");strcpy(filename,"uts_anndata");strcpy(test_dat_file,"uts_test.dat");var=atoi(argv[3]);break;
	case 4:strcpy(model_name,"eln");strcpy(filename,"eln_anndata");strcpy(test_dat_file,"eln_test.dat");var=atoi(argv[4]);break;
	}
      sprintf(fname,"gen_data_tmp_%s.c",model_name);
      fp=fopen(fname, "w");


      
      /*==========================   	FILE CREATION STARTS ============================== */
      fprintf(fp,"/*\t\t\tAum Sri Sairam\t\t*/\n\n");
      
      fprintf(fp,"\n\n\n#include<stdio.h>\n\n");
      fprintf(fp,"main()\n");
      fprintf(fp,"{\n\n");
      fprintf(fp,"float x[200],min[200],max[200],step[200],xx,tt[100],tti,ttp;\n");
      fprintf(fp,"int i=1,incr[200],total=0,j,k,count[200],l=1,m,mm;\n");
      fprintf(fp,"int counter=0,ord_opt,var_count=0,jc=1;\n");
      fprintf(fp,"char c[200],ans1, _ref[300][300];\n");
      fprintf(fp,"FILE *finpt, *fopt, *fresult, *finput, *fstep;\n\n");
      fprintf(fp,"total=%d;\n",var);
      fprintf(fp,"system(\"ls\");\n");
      fprintf(fp,"printf(\"\\n\\n\");\n");
      /*
	fprintf(fp,"printf(\" \\n\\n\\nPlease type the identification number for the data:\\t\");\n");
	fprintf(fp,"scanf(\"%%d\",&iden);\n");
	fprintf(fp,"getchar();\n");
	fprintf(fp,"printf(\" Type the filename from which the test.dat is to be generated:\\t\");\n");
	fprintf(fp,"getname(filename);\n");*/
      fprintf(fp,"printf(\"\\n\\nComponents that are to be varied \\n\");\n");
      fprintf(fp,"if((finpt=fopen(\"%s\",\"r\"))!=NULL)\n",filename);
      fprintf(fp,"	{\n");
      fprintf(fp,"		do\n");
      fprintf(fp,"		{\n");
      fprintf(fp,"	 	fscanf(finpt,\"%%f %%f %%f %%f %%d %%s\",&x[i],&min[i],&max[i],&step[i],&incr[i], &_ref[i]);\n");
      fprintf(fp,"		if(incr[i]==1 && step[i]==0)\n");
      fprintf(fp,"	    	if (max[i]<=min[i])\n");
      fprintf(fp,"			{\n");
      fprintf(fp,"			printf(\"\\n\\nsl.no\\tValue\\t\\tmin.\\t\\tmax.\\t\\tincr\\tTotal Data\");\n");
      fprintf(fp,"			printf(\"\\n\\n%%d.\\t%%f\\t%%f\\t%%f\\t%%f\\n\",i,x[i],min[i],max[i],step[i]);\n");
      fprintf(fp,"			printf(\" \\n\\nInvalid data set.....data number %%d.....Exiting to system\\n\\n\",i);\n");
      fprintf(fp,"			exit();\n");
      fprintf(fp,"			}\n");
      fprintf(fp,"	 	if (incr[i]==1)\n");
      fprintf(fp,"			{\n");
      fprintf(fp,"			counter++;\n");
      fprintf(fp,"			count[l++]=i;\n");
      fprintf(fp,"			}	\n");
      fprintf(fp," 		i++;\n");
      fprintf(fp,"		}while(i<=total);\n");
      fprintf(fp,"	}\n");
      fprintf(fp,"else\n");
      fprintf(fp,"{\n");
      fprintf(fp," printf(\"\\n\\n\\n\\n\\n\\n\\n\\n\\n\\n\\n\\n\\n\\nPlease run get_data and then run this program......\\n\\n\\n\\n\\n\\n\\n\\n\");\n");
      fprintf(fp," exit(1);\n");
      fprintf(fp,"} \n");
      fprintf(fp,"	\n");
      fprintf(fp,"	\n");
      fprintf(fp,"fclose(finpt);\n");
      fprintf(fp,"/*------------------------------------------------------------------------------------------------\n");
      fprintf(fp,"\n");
      fprintf(fp,"			***** CREATION OF test.dat STARTS HERE ****\n");
      fprintf(fp,"\n");
      fprintf(fp,"------------------------------------------------------------------------------------------------*/\n");
      fprintf(fp,"\n");
      fprintf(fp,"sprintf(c,\"variables_%s\");\n",iden);
      fprintf(fp,"fopt=fopen(\"%s\",\"w\");\n",test_dat_file);
      fprintf(fp,"fresult=fopen(c,\"w\");\n");
      fprintf(fp,"tti=1;\n");
      fprintf(fp,"for(mm=1;mm<l;mm++)\n");
      fprintf(fp,"	{\n");
      fprintf(fp," if(mm==1)\nprintf(\"\\n[ sl.no. ]\\t[ elt. ]\\t[ data line no. ]\\t[ const. value ]\\t[ Min. ]\\t[ Max. ]\\t[ Incr. ]\\t\\n\\n\");\n");
      fprintf(fp," 	printf(\"%%d\\t[ %%s ]\\t\\t %%d.\\t[ %%f ]\\t[ %%f ]\\t[ %%f ]\\t[ %%f ]\\n\",mm,_ref[count[mm]],count[mm],x[count[mm]],min[count[mm]],max[count[mm]],step[count[mm]]);\n");
      fprintf(fp,"	tt[mm]=(max[count[mm]]-min[count[mm]])/(step[count[mm]]);\n");
      fprintf(fp,"	tti=(tt[mm]+1)*(tti);\n");
      fprintf(fp,"	}\n");
      fprintf(fp,"m=1;\n");
      fprintf(fp,"\n");
      fprintf(fp,"if(counter>2) \n");
      fprintf(fp,"	{printf(\" \\n\\nThe number of Variables stepped are more than 2 ...\\n\\nExiting to System.....\\n\\n\");\n");
      fprintf(fp,"	 exit(1);\n");
      fprintf(fp,"	}\n");
      fprintf(fp,"\n");
      fprintf(fp,"if (counter>0 && counter>1)\n");
      fprintf(fp,"{\n");
      fprintf(fp,"  fstep=fopen(\"step_ref\",\"w\");\n");
      fprintf(fp,"  printf(\"\\n\\n\\n\\n\\tTWO VARIABLE STEPPING\\t\\n\");\n");
      fprintf(fp,"  printf(\"\\t---------------------\\t\\n\\n\");\n");
      fprintf(fp,"  printf(\" \\tWhich of the variables should be kept constant, while varying the other\\n\\n\");\n");
      fprintf(fp,"  printf(\"1.\\t[ %%s ]\",_ref[count[m]]);\n");
      fprintf(fp,"  printf(\"\\n2.\\t[ %%s ]\",_ref[count[m+1]]);\n");

      /*      fprintf(fp,"  printf(\"\\n\\n\\t\\t\\tEnter option:\\t\");\n");
	      fprintf(fp,"  scanf(\"%%d\",&ord_opt);\n"); */

      fprintf(fp,"\n");
      fprintf(fp,"\n");
      fprintf(fp,"switch(%d)\n",ord_opt);
      fprintf(fp,"{\n");
      fprintf(fp,"case 1 :\n");
      fprintf(fp," for(min[count[m]];min[count[m]]<=max[count[m]];min[count[m]]+=step[count[m]])\n");
      fprintf(fp,"	{\n");
      fprintf(fp,"		\n");
      fprintf(fp,"	for(xx=min[count[m+1]];xx<=max[count[m+1]];xx+=step[count[m+1]])\n");
      fprintf(fp,"		{\n");
      fprintf(fp,"			for(i=1;i<=total;i++)\n");
      fprintf(fp,"				{				\n");
      fprintf(fp,"				 if(i==count[m] ) \n");
      fprintf(fp,"					{	\n");
      fprintf(fp,"					 fprintf(fopt,\"%%f \",min[count[m]]);\n");
      fprintf(fp,"					 fprintf(fresult,\"%%f \",min[count[m]]);\n");
      fprintf(fp,"					}\n");
      fprintf(fp,"				 else \n");
      fprintf(fp,"					if(i== count[m+1])\n");
      fprintf(fp,"						{\n");
      fprintf(fp,"						 fprintf(fopt,\"%%f \",xx);\n");
      fprintf(fp,"						 fprintf(fresult,\"%%f \",xx);\n");
      fprintf(fp,"						}\n");
      fprintf(fp,"				 else\n");
      fprintf(fp,"					 fprintf(fopt,\"%%f \",x[i]);\n");
      fprintf(fp,"				}\n");
      fprintf(fp,"			fprintf(fopt,\"\\n\");\n");
      fprintf(fp,"			fprintf(fresult,\"\\n\");\n");
      fprintf(fp,"  			var_count+=1; \n");
      fprintf(fp,"\n");
      fprintf(fp,"		}\n");
      fprintf(fp,"					    \n");
      fprintf(fp,"    if(jc==1)\n");
      fprintf(fp,"     {\n");
      fprintf(fp,"      fclose(fstep);\n");
      fprintf(fp,"    \n");
      fprintf(fp,"     }\n");
      fprintf(fp,"     fstep=fopen(\"step_ref\",\"a\");\n");
      fprintf(fp,"     fprintf(fstep,\"step%%d\\t %%d %%s %%f %%s %%f %%f\\n\",jc++, var_count,_ref[count[m]],min[count[m]], _ref[count[m+1]], min[count[m+1]], max[count[m+1]]);\n");
      fprintf(fp,"     fclose(fstep);\n");
      fprintf(fp," \n");
      fprintf(fp,"	}	\n");
      fprintf(fp,"   break;\n");
      fprintf(fp,"\n");
      fprintf(fp,"case 2 :\n");
      fprintf(fp," var_count=0;\n");
      fprintf(fp," for(min[count[m+1]];min[count[m+1]]<=max[count[m+1]];min[count[m+1]]+=step[count[m+1]])\n");
      fprintf(fp,"	{		\n");
      fprintf(fp,"	for(xx=min[count[m]];xx<=max[count[m]];xx+=step[count[m]])\n");
      fprintf(fp,"		{\n");
      fprintf(fp,"			for(i=1;i<=total;i++)\n");
      fprintf(fp,"				{\n");
      fprintf(fp,"				\n");
      fprintf(fp,"				 if(i==count[m+1] ) \n");
      fprintf(fp,"					{	\n");
      fprintf(fp,"					 fprintf(fopt,\"%%f \",min[count[m+1]]);\n");
      fprintf(fp,"					 fprintf(fresult,\"%%f \",min[count[m+1]]);\n");
      fprintf(fp,"					}\n");
      fprintf(fp,"				 else \n");
      fprintf(fp,"					if(i== count[m])\n");
      fprintf(fp,"						{\n");
      fprintf(fp,"						 fprintf(fopt,\"%%f \",xx);\n");
      fprintf(fp,"						 fprintf(fresult,\"%%f \",xx);\n");
      fprintf(fp,"						}\n");
      fprintf(fp,"				 else\n");
      fprintf(fp,"					 fprintf(fopt,\"%%f \",x[i]);\n");
      fprintf(fp,"				\n");
      fprintf(fp,"				}\n");
      fprintf(fp,"\n");
      fprintf(fp,"			fprintf(fopt,\"\\n\");\n");
      fprintf(fp,"			fprintf(fresult,\"\\n\");\n");
      fprintf(fp," 	var_count+=1;\n");
      fprintf(fp,"		}\n");
      fprintf(fp," \n");
      fprintf(fp,"     if(jc==1)\n");
      fprintf(fp,"     {\n");
      fprintf(fp,"       fclose(fstep);\n");
      fprintf(fp,"     }\n");
      fprintf(fp,"     fstep=fopen(\"step_ref\",\"a\");\n");
      fprintf(fp,"     fprintf(fstep,\"step%%d\\t %%d %%s %%f %%s %%f %%f\\n\",jc++, var_count,_ref[count[m+1]],min[count[m+1]], _ref[count[m]],min[count[m]],max[count[m]]);\n");
      fprintf(fp,"     fclose(fstep);\n");
      fprintf(fp,"	}\n");
      fprintf(fp,"    fclose(fstep);\n");
      fprintf(fp,"    break;\n");
      fprintf(fp,"\n");
      fprintf(fp," default : system(\"clear\");\n");
      fprintf(fp,"	  printf (\"\\n\\n\\n----ERROR---- Unknown data option <Exiting to SYSTEM>\\n\\n\\n\\n \");exit(1);break;\n");
      fprintf(fp,"\n");
      fprintf(fp,"  } /* switch(ord_opt) ends here */\n");
      fprintf(fp,"}/* counter bracket ends here */\n");
      fprintf(fp,"\n");
      fprintf(fp,"else if(counter==1)\n");
      fprintf(fp,"	for(min[count[m]];min[count[m]]<=max[count[m]];min[count[m]]+=step[count[m]])\n");
      fprintf(fp,"	{\n");
      fprintf(fp,"			for(i=1;i<=total;i++)\n");
      fprintf(fp,"				{\n");
      fprintf(fp,"				 if(i==count[m] ) \n");
      fprintf(fp,"					{	\n");
      fprintf(fp,"					 fprintf(fopt,\"%%f \",min[count[m]]);\n");
      fprintf(fp,"					 fprintf(fresult,\"%%f \",min[count[m]]);\n");
      fprintf(fp,"					}\n");
      fprintf(fp,"				 else\n");
      fprintf(fp,"					 fprintf(fopt,\"%%f \",x[i]);\n");
      fprintf(fp,"				}\n");
      fprintf(fp,"			fprintf(fopt,\"\\n\");\n");
      fprintf(fp,"			fprintf(fresult,\"\\n\");\n");
      fprintf(fp,"	}	\n");
      fprintf(fp,"else if(counter==0)\n");
      fprintf(fp," 	 {\n");
      fprintf(fp," 	 for(i=1;i<=total;i++)\n");
      fprintf(fp,"	 fprintf(fopt,\"%%f \",x[i]);\n");
      fprintf(fp,"  	}	 \n");
      fprintf(fp,"fclose(fopt);\n");
      fprintf(fp,"\n");
      fprintf(fp,"printf(\"number of variables to be varied are :%%d\\n\\n\", counter);\n");
      fprintf(fp,"printf(\"\\n\\nThe total number of data in the test.dat file is %%f\\n\",tti);\n");
      fprintf(fp,"printf(\"\\n\\nUse the  file named  variables_%s along with the result file after predictions\");	\n",iden);
      fprintf(fp,"printf(\"\\n\\n Reference Help files: step_ref\");\n");
      fprintf(fp,"printf(\"\\n\\n\\t\\t\\t\\t\\t\\t\\t Thank you, Ananth- 307 Arup Building \\n\\n\\n\");\n");
      fprintf(fp,"}\n");
      fprintf(fp," getname(string)\n");
      fprintf(fp,"char string[];\n");
      fprintf(fp,"{\n");
      fprintf(fp,"char c;\n");
      fprintf(fp,"int i=0;\n");
      fprintf(fp,"do\n");
      fprintf(fp,"{\n");
      fprintf(fp,"	c=getchar();\n");
      fprintf(fp,"	string[i++]=c;\n");
      fprintf(fp,"}while(c!='\\n');\n");
      fprintf(fp,"string[i-1]='\\0';\n");
      fprintf(fp,"}\n");
      
      /*==========================   	FILE CREATION ENDS ============================== */
      
      fclose(fp);      
      /*execv("cc -o gen_data_tmp",argv[5],);
      system("rm gen_data_tmp.c");*/
      printf("\n\n Type ./gen_data_tmp_%s to run the program\n\n",model_name);
    } 
  
}
heading()
{
  system("clear");
  printf("  ************************************************************************************\n");
  printf(" \n 			 FILE CREATION PROGRAM \t\n" );
  printf("\n************************************************************************************\n");
}
instructions()
{
  printf("Create a file in which you type the data  in the following format\n\tACTUAL VALUE\tMINIMUM \tMAXIMUM \tSTEP\t0 OR 1 depending on whether u want to increment the variable or not\n");
  printf("\n\n");
}
